!== ॾ˴ؤ³
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: dcdatetimezone.f90,v 1.1.1.1 2008-09-23 09:56:37 morikawa Exp $
! Tag Name::  $Name: gtool5-20090228 $
! Copyright:: Copyright (C) GFD Dennou Club, 2000-2005. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
! Υե󶡤³ dc_date ⥸塼ˤ󶡤ޤ
!

subroutine DCDateTimeSetZone(time, zone, err)
  !
  !  *time* Υॾ *zone* ؤѹޤ.
  ! ¼Ūѹޤ.
  !
  !  *zone* ŬڤͤͿ줿,
  ! 顼ȯޤ.
  !  *err* ͿƤˤ *err*  .true. ֤,
  ! ץ³Ԥޤ.
  !
  use dc_types,      only: STRING
  use dc_date_types, only: DC_DATETIME, DC_DIFFTIME
  use dc_date, only: ValidZone, ZoneToDiff, toChar, Eval, &
    & operator(-), operator(+)
  use dc_error, only: StoreError, DC_EBADTIMEZONE, DC_NOERR
  use dc_message, only: MessageNotify
  use dc_trace, only: BeginSub, EndSub
  use dc_string, only: StoI
  implicit none
  type(DC_DATETIME), intent(inout):: time
  character(*), intent(in):: zone
  logical, intent(out), optional:: err
  type(DC_DIFFTIME):: diff, diff_in
  integer :: stat
  character(STRING) :: zone_in, cause_c
  character(*), parameter :: subname = 'DCDateTimeSetZone'
continue
  call BeginSub(subname, 'time=%c, zone=%c', &
    & c1=trim(toChar(time)), c2=trim(zone))
  stat = DC_NOERR
  cause_c = ''

  if (.not. ValidZone(zone)) then
    stat = DC_EBADTIMEZONE
    cause_c = zone
    if (present(err)) then
      call MessageNotify('W', subname, &
        & 'zone=<%c> is invalid.', &
        & c1=trim(zone))
    else
      goto 999
    end if
  end if

  call Eval(time, zone = zone_in)
  diff_in = ZoneToDiff(zone_in)
  diff = ZoneToDiff(zone)

  time = time + (diff_in - diff)
  time % zone = zone

999 continue
  call StoreError(stat, subname, err, cause_c)
  call EndSub(subname, 'time=%c', &
    & c1=trim(toChar(time)))
end subroutine DCDateTimeSetZone

function DCDateTimeZoneToDiff(zone) result(diff)
  !
  ! Ϳ륿ॾ dc_date_types#DC_DIFFTIME ѿؤ
  ! Ѵ֤ޤ. ॾɽ̵ʾ '+00:00'
  ! Ϳ줿Ȳᤷޤ.
  !
  use dc_date_types, only: DC_DIFFTIME
  use dc_date, only: ValidZone, DCDiffTimeCreate
  use dc_string, only: StoI
  implicit none
  type(DC_DIFFTIME):: diff
  character(*), intent(in):: zone
  integer:: hour, min, sgn
continue
  if (.not. ValidZone(zone)) then
    call DCDiffTimeCreate(diff)
  else
    if (zone(1:1) == '-') then
      sgn = 1
    else
      sgn = -1
    end if
    hour = StoI(zone(2:3))
    min = StoI(zone(5:6))
    call DCDiffTimeCreate(diff, hour = hour * sgn, min = min * sgn)
  end if
end function DCDateTimeZoneToDiff

function DCDateTimeValidZone(zone) result(result)
  !
  ! Ϳ륿ॾɽͭǤ
  ! .true. , ʳξ .false. ֤ޤ.
  !
  ! ॾɽ '+09:00' Τ褦, 1 ʸܤ '+' ޤ '-',
  ! 23, 56 ʸܤͤ, 4 ʸܤ ':' Ȥʤޤ.
  !
  implicit none
  character(*), intent(in):: zone
  logical:: result
continue
  result = .false.
  if (len(zone) < 6) return
  if (verify(zone(1:1), '+-') /= 0) return
  if (verify(zone(2:3), '1234567890') /= 0) return
  if (verify(zone(5:6), '1234567890') /= 0) return
  if (zone(4:4) /= ':') return
  result = .true.
end function DCDateTimeValidZone
